const dbSAPPS = require('../../helpers/db');
require('dotenv').config();
const { Op } = require('sequelize');

module.exports = {
    create,
    getAll,
    option,
    count,
    update,
    delete: _delete
};

/**
 * Format an array of dosageTypes by appending a modifier field to each company.
 * The modifier field is the full name of the user who last modified the company.
 * @param {Object[]} dosageTypes - The array of dosageTypes to format.
 * @returns {Promise<Object[]>} - The formatted array of dosageTypes.
 */
const formatWithModifier = async (dosageTypes) => {
    return Promise.all(
        dosageTypes.map(async (dosageType) => {
            const modifier = await dbSAPPS.User.findOne({
                where: {
                    id: dosageType.modified_by
                },
                attributes: ['full_name']
            });

            return {
                ...dosageType,
                modifier: modifier?.full_name
            };
        })
    );
};

/**
 * Retrieves all dosageTypes with their parent dosageType title.
 * @param {Object} params - The query parameters.
 * @param {number[]} params.dosageTypesId - The ids of the dosageTypes to retrieve.
 * @returns {Promise<Object>} - The response object with the dosageTypes and success status.
 */
async function getAll(params) {
    try {
        // filters
        const filterConditions = {};

        let dosageTypes = []
        dosageTypes = await dbSAPPS.DosageType.findAll({
            where: filterConditions,
            order: [['modified', 'DESC']],
        });

        dosageTypes = dosageTypes.map(dosageType => {
            return {
                ...dosageType.dataValues
            }
        });

        dosageTypes = await formatWithModifier(dosageTypes);

        return {
            dosageTypes,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Get dosageType items with their respective settings.
 * @param {Object} params - An object that contains parameters to filter the dosageType items.
 * @param {boolean|string} params.is_parent - A boolean or string indicating whether the dosageType items should be parents or not.
 * @returns {Promise<Object>} Resolves with an object that contains the dosageType items and a success flag.
 * @example
 * const result = await option({ is_parent: true });
 * console.log(result);
 */
async function option(params) {
    try {
        // filter
        const filterConditions = {};

        let options = [];
        options = await dbSAPPS.DosageType.findAll({
            attributes: ['id', 'name', 'display_name'],
            where: filterConditions,
            order: [['name', 'ASC']]
        });

        return {
            options,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Count active dosageType items
 * 
 * @returns {Promise<{
 *   count: number,
 *   success: boolean,
 *   message: string
 * }>} 
 */

async function count(params) {
    try {
        // filter
        const filterConditions = {};

        const count = await dbSAPPS.DosageType.count({
            where: filterConditions
        });

        return {
            count,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Creates a new dosageType item.
 * 
 * @param {Object} params - The new dosageType item data.
 * @param {string} params.name - The name of the dosageType item.
 * @param {string} params.title - The title of the dosageType item.
 * @param {number} [params.parent_id] - The ID of the parent dosageType item.
 * @param {string} [params.url] - The URL of the dosageType item.
 * @param {string} [params.icon] - The icon of the dosageType item.
 * @param {string} [params.type=link] - The type of the dosageType item (link, group, collapse, separator).
 * @param {boolean} [params.enabled=true] - Whether the dosageType item is enabled.
 * @param {number} [params.creation=Date.now()] - The creation timestamp of the dosageType item.
 * @param {number} [params.modified=Date.now()] - The last modification timestamp of the dosageType item.
 * @param {number} [params.owner=1] - The ID of the user who created the dosageType item.
 * @param {number} [params.modified_by=1] - The ID of the user who last modified the dosageType item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the dosageType item creation process.
 */
async function create(params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const existingDisplayName = await dbSAPPS.DosageType.findOne({
            where: { display_name: params.display_name },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await dbSAPPS.DosageType.create(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Updates an existing dosageType item.
 * 
 * @param {number} id - The ID of the dosageType item to update.
 * @param {Object} params - The updated dosageType item data.
 * @param {string} [params.name] - The new name of the dosageType item.
 * @param {string} [params.title] - The new title of the dosageType item.
 * @param {number} [params.parent_id] - The new parent ID of the dosageType item.
 * @param {string} [params.url] - The new URL of the dosageType item.
 * @param {string} [params.icon] - The new icon of the dosageType item.
 * @param {string} [params.type] - The new type of the dosageType item (link, group, collapse, separator).
 * @param {boolean} [params.enabled] - Whether the dosageType item is enabled or not.
 * @param {number} [params.creation] - The new creation timestamp of the dosageType item.
 * @param {number} [params.modified] - The new last modification timestamp of the dosageType item.
 * @param {number} [params.owner] - The new ID of the user who created the dosageType item.
 * @param {number} [params.modified_by] - The new ID of the user who last modified the dosageType item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the dosageType item update process.
 */
async function update(id, params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const dosageType = await dbSAPPS.DosageType.findByPk(id);
        if (!dosageType) return { success: false, message: 'ID not found!' };

        // validate existing
        const existingDisplayName = await dbSAPPS.DosageType.findOne({
            where: {
                display_name: params.display_name,
                id: {
                    [Op.ne]: id
                }
            },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await dosageType.update(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Delete a dosageType
 * @param {number} id - the id of the dosageType
 * @returns {Promise<object>} - the result of the delete
 */
async function _delete(id) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const dosageType = await dbSAPPS.DosageType.findByPk(id);
        if (!dosageType) return { success: false, message: 'ID not found!' };

        // delete
        await dosageType.destroy({ transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Deleted successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to delete, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}
